(* 
 * Copyright (c) 2001 The University of Wroclaw.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: gontbind.mli,v 1.11 2001/11/28 22:43:06 malekith Exp $
 *
 * Module interface: Gontbind
 * Description: Interface to symbol binder. (see .ml file for more info)
 *)

open Gontutil

type ctx

(* Return initial binding context for named module. *)
val init_bind : (* module name *) string -> ctx

(* Modify decl in place, adding symbol entries to Ref terms. This musn't be
 * called more then once in a toplevel declaration (i.e. don't call it for 
 * nested functions). *)
val bind : ctx -> decl -> ctx

(* Return list of symbols, at given scoping (function) level, that needs 
 * to put into the closure becouse they are referenced in stmts. *)
val closure : int -> stmt -> (bool * symbol list)
;;
